#pragma once

class Cylinder {
    public:
       Cylinder();

       void Draw(CDC & dc);

       int GetEyeAngle();
       void GetColor(COLORREF & light, COLORREF & dark);
       COLORREF GetDarkColor();
       int GetHeight();
       int GetLightingAngle();
       COLORREF GetLightColor();
       BOOL GetMatrix(XFORM & M);
       CPoint GetPos();
       CSize GetSize();
       int GetWidth(); 

       void SetColor(COLORREF light, COLORREF dark);
       void SetDarkColor(COLORREF c);
       void SetEyeAngle(int degrees);
       void SetHeight(int height); 
       void SetLightingAngle(int degrees); 
       void SetLightColor(COLORREF c);
       void SetMatrix(XFORM * M);
       void SetPos(CPoint pt);
       void SetPos(int x, int y);
       void SetSize(CSize sz);
       void SetWidth(int width);

    protected:
       CPoint Centroid;
       XFORM Matrix;
       BOOL UseMatrix;
       int width;
       int height;
       int eyeAngle;
       int lightAngle;
       COLORREF darkColor;
       COLORREF lightColor;
};


