// CylinderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "CylinderDlg.h"
#include "degrees.h"
#include "toclip.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#if 0
#define MOVETRACE(x) TRACE x
#else
#define MOVETRACE(x)
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CAboutDlg();

// Dialog Data
        enum { IDD = IDD_ABOUTBOX };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
        DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CCylinderDlg dialog



/****************************************************************************
*                         CCylinderDlg::CCylinderDlg
* Inputs:
*       CWnd * pParent
* Effect: 
*       Constructor
****************************************************************************/

CCylinderDlg::CCylinderDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CCylinderDlg::IDD, pParent)
{
        m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


/****************************************************************************
*                         CCylinderDlg::DoDataExchange
* Inputs:
*       CDataExchange * pDX:
* Result: void
*       
* Effect: 
*       Binds controls to variables
****************************************************************************/

void CCylinderDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_DARKCOLOR, c_SetDark);
    DDX_Control(pDX, IDC_LIGHTCOLOR, c_SetLight);
    DDX_Control(pDX, IDC_WIDTH, c_Width);
    DDX_Control(pDX, IDC_LIGHT, c_Light);
    DDX_Control(pDX, IDC_HEIGHT, c_Height);
    DDX_Control(pDX, IDC_EYE, c_Eye);
    DDX_Control(pDX, IDC_EYE_CAPTION, x_Eye);
    DDX_Control(pDX, IDC_HEIGHT_CAPTION, x_Height);
    DDX_Control(pDX, IDC_WIDTH_CAPTION, x_Width);
    DDX_Control(pDX, IDC_LIGHT_CAPTION, x_Light);
    DDX_Control(pDX, IDC_CYLINDER, c_Cylinder);
    DDX_Control(pDX, IDC_CODE, c_Code);
    DDX_Control(pDX, IDC_FRAME, c_Frame);
    DDX_Control(pDX, IDC_M11, c_M11);
    DDX_Control(pDX, IDC_M12, c_M12);
    DDX_Control(pDX, IDC_M22, c_M22);
    DDX_Control(pDX, IDC_M21, c_M21);
    DDX_Control(pDX, IDC_ENABLE_XFORM, c_EnableTransform);
    DDX_Control(pDX, IDC_MX, c_DX);
    DDX_Control(pDX, IDC_MY, c_DY);
    DDX_Control(pDX, IDC_IDENTITY, c_Identity);
    DDX_Control(pDX, IDC_ROTATION, c_Rotate);
    DDX_Control(pDX, IDC_M11_VAL, c_V11);
    DDX_Control(pDX, IDC_M12_VAL, c_V12);
    DDX_Control(pDX, IDC_M21_VAL, c_V21);
    DDX_Control(pDX, IDC_M22_VAL, c_V22);
    DDX_Control(pDX, IDC_MDX_VAL, c_VDX);
    DDX_Control(pDX, IDC_MDX_VAL2, c_VDY);
    DDX_Control(pDX, IDC_ROTATE_IMAGE, x_Rotate);
    DDX_Control(pDX, IDC_ROTATE_VALUE, c_VRotate);
    DDX_Control(pDX, IDC_EYE_VALUE, c_VEye);
    DDX_Control(pDX, IDC_MATRIX_CONTROLS, c_MatrixFrame);
    DDX_Control(pDX, IDC_COPY, c_Copy);
}

/****************************************************************************
*                                 Message Map
****************************************************************************/

BEGIN_MESSAGE_MAP(CCylinderDlg, CDialog)
        ON_WM_SYSCOMMAND()
        ON_WM_QUERYDRAGICON()
        //}}AFX_MSG_MAP
        ON_WM_CLOSE()
        ON_WM_HSCROLL()
        ON_WM_VSCROLL()
        ON_WM_SIZE()
        ON_WM_GETMINMAXINFO()
        ON_BN_CLICKED(IDC_DARKCOLOR, OnBnClickedDarkcolor)
        ON_BN_CLICKED(IDC_LIGHTCOLOR, OnBnClickedLightcolor)
        ON_BN_CLICKED(IDC_ENABLE_XFORM, OnBnClickedEnableXform)
        ON_BN_CLICKED(IDC_IDENTITY, OnBnClickedIdentity)
        ON_BN_CLICKED(IDC_ZERO, OnBnClickedZero)
        ON_BN_CLICKED(IDC_COPY, OnBnClickedCopy)
END_MESSAGE_MAP()


// CCylinderDlg message handlers


/****************************************************************************
*                          CCylinderDlg::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Binds controls to variables
****************************************************************************/

BOOL CCylinderDlg::OnInitDialog()
   {
    CDialog::OnInitDialog();

    // Add "About..." menu item to system menu.

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
       {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
           {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
           }
       }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);                 // Set big icon
    SetIcon(m_hIcon, FALSE);                // Set small icon

    // TODO: Add extra initialization here
    c_Eye.SetRange(-45,45);
    c_Eye.SetTicFreq(5);
    c_Eye.SetPageSize(5);

    c_Height.SetRange(0,100);
    c_Height.SetTicFreq(10);
    c_Height.SetPageSize(10);

    c_Light.SetRange(-90,90);
    c_Light.SetTicFreq(10);
    c_Light.SetPageSize(10);

    c_Width.SetRange(0,100);
    c_Width.SetTicFreq(10);
    c_Width.SetPageSize(10);
        
    ZeroData();
    
    c_Cylinder.SetEyeAngle(c_Eye.GetPos());
    c_Cylinder.SetLightingAngle(c_Light.GetPos());
    c_Cylinder.SetWidth(c_Width.GetPos());
    c_Cylinder.SetHeight(c_Height.GetPos());

    c_Rotate.SetRange(-90,90);
    c_Rotate.SetPos(0);
    c_Rotate.SetTicFreq(10);
    c_Rotate.SetPageSize(10);

#define TRANSFORM_RANGE 5000
#define TRANSFORM_FACTOR 1000.0f
    c_M11.SetRange(-TRANSFORM_RANGE, TRANSFORM_RANGE);
    c_M11.SetTicFreq(TRANSFORM_RANGE / 10);
    c_M11.SetPageSize(TRANSFORM_RANGE / 100);

    c_M12.SetRange(-TRANSFORM_RANGE, TRANSFORM_RANGE);
    c_M12.SetTicFreq(TRANSFORM_RANGE / 10);
    c_M12.SetPageSize(TRANSFORM_RANGE / 100);

    c_M21.SetRange(-TRANSFORM_RANGE, TRANSFORM_RANGE);
    c_M21.SetTicFreq(TRANSFORM_RANGE / 10);
    c_M21.SetPageSize(TRANSFORM_RANGE / 100);

    c_M22.SetRange(-TRANSFORM_RANGE, TRANSFORM_RANGE);
    c_M22.SetTicFreq(TRANSFORM_RANGE / 10);
    c_M22.SetPageSize(TRANSFORM_RANGE / 100);

#define XYRANGE 150
    c_DX.SetRange(-XYRANGE, XYRANGE);
    c_DX.SetTicFreq(XYRANGE / 10);
    c_DX.SetPageSize(XYRANGE / 100);


    c_DY.SetRange(-XYRANGE, XYRANGE);
    c_DY.SetTicFreq(XYRANGE / 10);
    c_DY.SetPageSize(XYRANGE / 100);

    SetIdentity();

    CFont * f = GetFont();
    LOGFONT lf;
    f->GetLogFont(&lf);
    lf.lfEscapement = 900;
    lf.lfOrientation = 900;
    Vertical90.CreateFontIndirect(&lf);
    x_Height.SetFont(&Vertical90);

    lf.lfEscapement = 2700;
    lf.lfOrientation = 2700;
    Vertical270.CreateFontIndirect(&lf);
    x_Eye.SetFont(&Vertical270);
//    x_Height.SetFont(&Vertical90);

    COLORREF dark = RGB(0,0,0);
    c_Cylinder.SetDarkColor(dark);
    c_SetDark.SetDarkColor(dark);
    c_SetLight.SetDarkColor(dark);
    c_SetDark.SetLeft(TRUE);
    
    COLORREF light = RGB(255, 255, 255);
    c_Cylinder.SetLightColor(light);
    c_SetDark.SetLightColor(light);
    c_SetLight.SetLightColor(light);
    c_SetLight.SetLeft(FALSE);

    c_Identity.LoadBitmaps(IDB_IDENTITY);
    c_Copy.LoadBitmaps(IDB_COPY);

    HBITMAP bmp = (HBITMAP)::LoadImage(AfxGetInstanceHandle(),
                                       MAKEINTRESOURCE(IDB_ROTATE),
                                       IMAGE_BITMAP,               
                                       0, 0,                       
                                       LR_SHARED | LR_LOADMAP3DCOLORS);
    x_Rotate.SetBitmap(bmp);                                       

    updateControls();

    return TRUE;  // return TRUE  unless you set the focus to a control
   }

/****************************************************************************
*                          CCylinderDlg::OnSysCommand
* Inputs:
*       
* Result: void
*       
* Effect: 
*       Handles WM_SYSCOMMAND
****************************************************************************/

void CCylinderDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
        if ((nID & 0xFFF0) == IDM_ABOUTBOX)
        {
                CAboutDlg dlgAbout;
                dlgAbout.DoModal();
        }
        else
        {
                CDialog::OnSysCommand(nID, lParam);
        }
}


// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCylinderDlg::OnQueryDragIcon()
   {
    return static_cast<HCURSOR>(m_hIcon);
   }

/****************************************************************************
*                              CCylinderDlg::OnOK
* Result: void
*       
* Effect: 
*       Does nothing; avoids exiting app with <enter> key
****************************************************************************/

void CCylinderDlg::OnOK()
   {
   }

/****************************************************************************
*                            CCylinderDlg::OnCancel
* Result: void
*       
* Effect: 
*       Nothing; avoids exiting the app on <esc> key
****************************************************************************/

void CCylinderDlg::OnCancel()
    {
    }

/****************************************************************************
*                            CCylinderDlg::OnClose
* Result: void
*       
* Effect: 
*       Closes the app
****************************************************************************/

void CCylinderDlg::OnClose()
    {
     CDialog::OnOK();
    }

/****************************************************************************
*                           CCylinderDlg::SetMatrix
* Result: void
*       
* Effect: 
*       Computes a transform matrix
****************************************************************************/

void CCylinderDlg::SetMatrix()
    {
     XFORM M;
     M.eM11 = (FLOAT)c_M11.GetPos() / TRANSFORM_FACTOR;
     M.eM12 = (FLOAT)c_M12.GetPos() / TRANSFORM_FACTOR;
     M.eM21 = (FLOAT)c_M21.GetPos() / TRANSFORM_FACTOR;
     M.eM22 = (FLOAT)c_M22.GetPos() / TRANSFORM_FACTOR;
     M.eDx = (FLOAT)c_DX.GetPos();
     M.eDy = (FLOAT)c_DY.GetPos();

     CString s;

     s.Format(_T("%.3f"), M.eM11);
     c_V11.SetWindowText(s);

     s.Format(_T("%.3f"), M.eM12);
     c_V12.SetWindowText(s);

     s.Format(_T("%.3f"), M.eM21);
     c_V21.SetWindowText(s);

     s.Format(_T("%.3f"), M.eM22);
     c_V22.SetWindowText(s);

     s.Format(_T("%.3f"), M.eDx);
     c_VDX.SetWindowText(s);
     
     s.Format(_T("%.3f"), M.eDy);
     c_VDY.SetWindowText(s);

     c_Cylinder.SetMatrix(M);
    } // CCylinderDlg::SetMatrix

/****************************************************************************
*                           CCylinderDlg::OnHScroll
* Inputs:
*       
* Result: void
*       
* Effect: 
*       Distributes the notification to the appropriate handler
****************************************************************************/

void CCylinderDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
    {
     int low;
     int high;
     int pos;

     if(pScrollBar == (CScrollBar *)&c_Light)
        { /* light change */
         c_Light.GetRange(low, high);
         pos = c_Light.GetPos();
         MOVETRACE((_T("Light: %d...%d...%d\n"), low, pos, high));
         c_Cylinder.SetLightingAngle(pos);
         c_Cylinder.Invalidate();
        } /* light change */

     if(pScrollBar == (CScrollBar *)&c_Width)
        { /* width change */
         c_Width.GetRange(low, high);
         pos = c_Width.GetPos();
         MOVETRACE((_T("Width: %d...%d...%d\n"), low, pos, high));
         c_Cylinder.SetWidth(pos);
        } /* width change */

     // it might be a matrix change
     if(pScrollBar == (CScrollBar *)&c_M11 ||
        pScrollBar == (CScrollBar *)&c_M12 ||
        pScrollBar == (CScrollBar *)&c_M21 ||
        pScrollBar == (CScrollBar *)&c_M22 ||
        pScrollBar == (CScrollBar *)&c_DX  ||
        pScrollBar == (CScrollBar *)&c_DY)
        SetMatrix();
     
     CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
    }

/****************************************************************************
*                     CCylinderDlg::GetClientCoordinates
* Inputs:
*       CWnd & wnd: Window
* Result: CRect
*       Window coordinates, in client coordinate frame
****************************************************************************/

CRect CCylinderDlg::GetClientCoordinates(CWnd & wnd)
    {
     CRect r;
     wnd.GetWindowRect(&r);
     ScreenToClient(&r);
     return r;
    } // CCylinderDlg::GetClientCoordinates

/****************************************************************************
*                       CCylinderDlg::Show
* Inputs:
*       CEdit & ctl: Control to set
*       int degrees: Degrees value to show
* Result: void
*       
* Effect: 
*       Shows the degrees in the control
****************************************************************************/

void CCylinderDlg::ShowDegrees(CEdit & ctl, int degrees)
    {
     CString s;
     s.Format(_T("%d"), degrees);
     CString old;
     ctl.GetWindowText(old);
     if(old != s)
        ctl.SetWindowText(s);
    } // CCylinderDlg::Show

/****************************************************************************
*                           CCylinderDlg::DoRotate
* Result: void
*       
* Effect: 
*       Rotates the image (replaces the current 4-element matrix)
****************************************************************************/

void CCylinderDlg::DoRotate()
    {
     int degrees = c_Rotate.GetPos();
     ShowDegrees(c_VRotate, degrees);
     
     double theta = DEGREES_TO_RADIANS(degrees);

     //========================
     // cos(theta)  sin(theta)
     // -sin(theta) cos(theta)
     //========================

     int M11 = (int)(cos(theta) * TRANSFORM_FACTOR);
     int M12 = (int)(sin(theta) * TRANSFORM_FACTOR);
     int M21 = (int)(-sin(theta) * TRANSFORM_FACTOR);
     int M22 = (int)(cos(theta) * TRANSFORM_FACTOR);
     c_M11.SetPos(M11);
     c_M12.SetPos(M12);
     c_M21.SetPos(M21);
     c_M22.SetPos(M22);

     SetMatrix();
     
    } // CCylinderDlg::DoRotate

/****************************************************************************
*                           CCylinderDlg::OnVScroll
* Inputs:
*       
* Result: void
*       
* Effect: 
*       Distributes the notification to the appropriate handler
****************************************************************************/

void CCylinderDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
    {
     int low;
     int high;
     int pos;

     if(pScrollBar == (CScrollBar *)&c_Eye)
        { /* eye change */
         c_Eye.GetRange(low, high);
         pos = c_Eye.GetPos();
         MOVETRACE((_T("Eye: %d...%d...%d\n"), low, pos, high));
         c_Cylinder.SetEyeAngle(pos);
         ShowDegrees(c_VEye, pos);
        } /* eye change */

     if(pScrollBar == (CScrollBar *)&c_Height)
        { /* height change */
         c_Height.GetRange(low, high);
         pos = c_Height.GetPos();
         MOVETRACE((_T("Height: %d...%d...%d\n"), low, pos, high));
         c_Cylinder.SetHeight(pos);
        } /* height change */

     if(pScrollBar == (CScrollBar *)&c_Rotate)
        { /* rotation change */
         DoRotate();
        } /* rotation change */
     CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
    }

/****************************************************************************
*                        CCylinderDlg::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CCylinderDlg::updateControls()
    {
     BOOL enable = c_EnableTransform.GetCheck() == BST_CHECKED;
     UINT show = enable ? SW_SHOW : SW_HIDE;
     c_M11.EnableWindow(enable);
     c_M11.ShowWindow(show);

     c_M12.EnableWindow(enable);
     c_M12.ShowWindow(show);

     c_M21.EnableWindow(enable);
     c_M21.ShowWindow(show);

     c_M22.EnableWindow(enable);
     c_M22.ShowWindow(show);

     c_DX.EnableWindow(enable);
     c_DX.ShowWindow(show);

     c_DY.EnableWindow(enable);
     c_DY.ShowWindow(show);

     c_Identity.EnableWindow(enable);
     c_Identity.ShowWindow(show);
     
     c_Cylinder.EnableXFORM(enable);

     c_Rotate.EnableWindow(enable);
     c_Rotate.ShowWindow(show);

     x_Rotate.ShowWindow(show);

     c_V11.ShowWindow(show);
     c_V12.ShowWindow(show);
     c_V21.ShowWindow(show);
     c_V22.ShowWindow(show);
     c_VDX.ShowWindow(show);
     c_VDY.ShowWindow(show);
     c_VRotate.ShowWindow(show);

     ShowDegrees(c_VRotate, c_Rotate.GetPos());
     ShowDegrees(c_VEye, c_Eye.GetPos());
    } // CCylinderDlg::updateControls

/****************************************************************************
*                             CCylinderDlg::OnSize
* Inputs:
*       UINT nType:
*       int cx:
*       int cy:
* Result: void
*       
* Effect: 
*       Resizes the image
****************************************************************************/

void CCylinderDlg::OnSize(UINT nType, int cx, int cy)
    {
     CDialog::OnSize(nType, cx, cy);

     if(nType == SIZE_MINIMIZED)
        return;
     
     /*****************************************************************************
      (0,0)
      +---------------------------------------------------------------+
      |                    gap1                                       |
      |         +--------------------------+                          |
      |         |         x_Width          |                          |
      |         +--------------------------+                          |
      |                    gap2                          [1]          |
      |         +--------------------------+             +--+         |
      |         |         c_Width          |             | @|         |
      |         +--------------------------+             +--+         |
      |                    gap3                                       |
      | +--+ +--+ +--------------------------+ +--+ +--+ +--+         |
      | |  | |  | |                          | |  | |  | |  |         |
      | |  | |  | |       c_cylinder         | |  | |  | |  |         |
      |g|x |g|c |g|                          |g|  |g|  |g|c |         |
      |a|_ |a|_ |a|                          |a| c|a| x|a|_ |         |
      |p|H |p|H |p|                          |p| _|p| _|p|R |         |
      |4|e |5|e |6|                          |7| E|8| E|1|o |         |
      | |i | |i | |                          | | y| | y|2|t |         |
      | |g | |g | |                          | | e| | e| |a |         |
      | |h | |h | |                          | |  | |  | |t |         |
      | |t | |t | |                          | |  | |  | |e |         |
      | |  | |  | |                          | |  | |  | |  |         |
      | |  | |  | |                          | |  | |  | |  |         |
      | |  | |  | |                          | |  | |  | |  |         |
      | +--+ +--+ +--------------------------+ +--+ +--+ +--+         |
      |                       gap9             [2]       [3]          |
      |           +--------------------------+ +--+      +--+         |
      |           |         c_Light          | |  |      |  |         |
      |           +--------------------------+ +--+      +--+         |
      |                       gap10                                   |
      |           +--------------------------+                        |
      |           |         x_Light          |                        |
      |           +--------------------------+                        |
      |                       gap11                                   |
      +---------------------------------------------------------------+
      |                           c_Code                              |
      |                                                               |
      +---------------------------------------------------------------+
                                                                      ^
                                                                      |
                                      (client.Width(), client.Height())
      [1] x_Rotate
      [2] c_VEye
      [3] c_VRotate
      *****************************************************************************/

     if(c_Code.GetSafeHwnd() != NULL &&
        c_Height.GetSafeHwnd() != NULL &&
        x_Height.GetSafeHwnd() != NULL &&
        c_Eye.GetSafeHwnd() != NULL &&
        x_Eye.GetSafeHwnd() != NULL &&
        c_Width.GetSafeHwnd() != NULL &&
        x_Width.GetSafeHwnd() != NULL &&
        c_Light.GetSafeHwnd() != NULL &&
        x_Light.GetSafeHwnd() != NULL &&
        c_VEye.GetSafeHwnd() != NULL
       )
        { /* can resize */
         CRect client;
         GetClientRect(&client);

         CRect codeRect = GetClientCoordinates(c_Code);
         CRect eyeScrollerRect = GetClientCoordinates(c_Eye);
         CRect eyeCaptionRect = GetClientCoordinates(x_Eye);
         CRect widthScrollerRect = GetClientCoordinates(c_Width);
         CRect widthCaptionRect = GetClientCoordinates(x_Width);
         CRect lightScrollerRect = GetClientCoordinates(c_Light);
         CRect lightCaptionRect = GetClientCoordinates(x_Light);
         CRect heightScrollerRect = GetClientCoordinates(c_Height);
         CRect heightCaptionRect = GetClientCoordinates(x_Height);
         CRect cylinderRect = GetClientCoordinates(c_Cylinder);
         CRect rotateRect = GetClientCoordinates(c_Rotate);
         CRect rotateIconRect = GetClientCoordinates(x_Rotate);

         // Compute the gaps
         int gap1 = widthCaptionRect.top;
         int gap2 = widthScrollerRect.top - widthCaptionRect.bottom;
         int gap3 = cylinderRect.top - widthScrollerRect.bottom;
         int gap4 = heightCaptionRect.left;
         int gap5 = heightScrollerRect.left - heightCaptionRect.right;
         int gap6 = cylinderRect.left - heightScrollerRect.right;
         int gap7 = eyeScrollerRect.left - cylinderRect.right;
         int gap8 = eyeCaptionRect.left - eyeScrollerRect.right;
         int gap9 = lightScrollerRect.top - cylinderRect.bottom;
         int gap10 = lightCaptionRect.top - lightScrollerRect.bottom;
         int gap11 = codeRect.top - lightCaptionRect.bottom;
         int gap12 = rotateRect.left - eyeCaptionRect.right;

         // Verify the controls were not laid down impropery
         // They must not overlap
         ASSERT(gap1 >= 0);
         ASSERT(gap2 >= 0);
         ASSERT(gap3 >= 0);
         ASSERT(gap4 >= 0);
         ASSERT(gap5 >= 0);
         ASSERT(gap6 >= 0);
         ASSERT(gap7 >= 0);
         ASSERT(gap8 >= 0);
         ASSERT(gap9 >= 0);
         ASSERT(gap10 >= 0);
         ASSERT(gap11 >= 0);
         ASSERT(gap12 >= 0);

         //  Now compute the size of the image rectangle
         //  Note that the image will never get wider than square
         //  but it might be narrower than square

         //----------------
         // Compute width possible
         //----------------

         CSize image;
         MOVETRACE((_T("-------------------\n")));

#ifdef _DEBUG // for TRACE output
         image.cx = client.Width();
#endif
         image.cy = client.Height();
         MOVETRACE((_T("client: image{%d, %d}\n"), image.cx, image.cy));

         image.cy -= gap1;
         MOVETRACE((_T("-gap1 (%d) image{%d, %d}\n"), gap1, image.cx, image.cy));

         image.cy -= widthCaptionRect.Height();
         MOVETRACE((_T("-lightScrollerRect.Height (%d) image{%d, %d}\n"), widthCaptionRect.Height(), image.cx, image.cy));         

         image.cy -= gap2;
         MOVETRACE((_T("-gap2 (%d) image{%d, %d}\n"), gap2, image.cx, image.cy));

         image.cy -= widthScrollerRect.Height();
         MOVETRACE((_T("-lightScrollerRect.Height (%d) image{%d, %d}\n"), widthScrollerRect.Height(), image.cx, image.cy));

         image.cy -= gap3;
         MOVETRACE((_T("-gap3 (%d) image{%d, %d}\n"), gap3, image.cx, image.cy));

         image.cy -= gap9;
         MOVETRACE((_T("-gap9 (%d) image{%d, %d}\n"), gap9, image.cx, image.cy));

         image.cy -= lightScrollerRect.Height();
         MOVETRACE((_T("-lightScrollerRect.Height (%d) image{%d, %d}\n"), lightScrollerRect.Height(), image.cx, image.cy));

         image.cy -= gap10;
         MOVETRACE((_T("-gap10 (%d) image{%d, %d}\n"), gap10, image.cx, image.cy));

         image.cy -= lightCaptionRect.Height();
         MOVETRACE((_T("-lightCaptionRect.Height (%d) image{%d, %d}\n"), lightCaptionRect.Height(), image.cx, image.cy));

         image.cy -= gap11;
         MOVETRACE((_T("-gap11 (%d) image{%d, %d}\n"), gap11, image.cx, image.cy));

         image.cy -= codeRect.Height(); // code stays same size
         MOVETRACE((_T("-codeRect.Height (%d) image{%d, %d}\n"), codeRect.Height(), image.cx, image.cy));

         //------------------------
         // Compute height possible
         //------------------------
         image.cx = client.Width();
         MOVETRACE((_T("client: image{%d, %d}\n"), image.cx, image.cy));
         
         image.cx -= gap4;
         MOVETRACE((_T("-gap4 (%d) image{%d, %d}\n"), gap4, image.cx, image.cy));

         image.cx -= heightScrollerRect.Width();
         image.cx -= gap5;
         MOVETRACE((_T("-gap5 (%d) image{%d, %d}\n"), gap5, image.cx, image.cy));
         image.cx -= heightCaptionRect.Width();
         image.cx -= gap6;
         MOVETRACE((_T("-gap6 (%d) image{%d, %d}\n"), gap6, image.cx, image.cy));
         image.cx -= gap7;
         MOVETRACE((_T("-gap7 (%d) image{%d, %d}\n"), gap7, image.cx, image.cy));
         image.cx -= eyeScrollerRect.Width();
         image.cx -= gap8;
         MOVETRACE((_T("-gap8 (%d) image{%d, %d}\n"), gap8, image.cx, image.cy));
         image.cx -= eyeCaptionRect.Width();

         MOVETRACE((_T("image{%d, %d}\n"), image.cx, image.cy));
         if(image.cx > image.cy)
            image.cx = image.cy;

         HDWP wndpos = ::BeginDeferWindowPos(72);
         //----------------
         // x_Width
         //----------------
         wndpos = ::DeferWindowPos(wndpos, x_Width.m_hWnd, NULL,
                                   0, 0,
                                   image.cx, widthCaptionRect.Height(),
                                   SWP_NOMOVE | SWP_NOZORDER);

         //----------------
         // c_Width
         //----------------
         wndpos = ::DeferWindowPos(wndpos, c_Width.m_hWnd, NULL,
                                   0, 0,
                                   image.cx, widthScrollerRect.Height(),
                                   SWP_NOMOVE | SWP_NOZORDER);

         //----------------
         // x_Height
         //----------------
         wndpos = ::DeferWindowPos(wndpos, x_Height.m_hWnd, NULL,
                                   0, 0,
                                   heightCaptionRect.Width(),
                                   image.cy,
                                   SWP_NOMOVE | SWP_NOZORDER);

         //----------------
         // c_Height
         //----------------
         wndpos = ::DeferWindowPos(wndpos, c_Height.m_hWnd, NULL,
                                   0, 0,
                                   heightScrollerRect.Width(),
                                   image.cy,
                                   SWP_NOMOVE | SWP_NOZORDER);
         //----------------
         // c_Cylinder
         //----------------
         wndpos = ::DeferWindowPos(wndpos,c_Cylinder.m_hWnd, NULL, 0, 0,
                                  image.cx, image.cy, SWP_NOMOVE | SWP_NOZORDER);

         //----------------
         // c_Eye
         //----------------
         wndpos = ::DeferWindowPos(wndpos, c_Eye.m_hWnd, NULL,
                                   cylinderRect.left + image.cx + gap7,
                                   eyeScrollerRect.top,
                                   eyeScrollerRect.Width(),
                                   image.cy,
                                   SWP_NOZORDER);
         //----------------
         // x_Eye
         //----------------
         wndpos = ::DeferWindowPos(wndpos, x_Eye.m_hWnd, NULL,
                          /*  x */ cylinderRect.left + image.cx + gap7 +
                                            eyeScrollerRect.Width() + gap8,
                          /*  y */ eyeCaptionRect.top,
                          /* cx */ eyeCaptionRect.Width(),
                          /* cy */ image.cy,
                                   SWP_NOZORDER);
                                   
         //----------------
         // c_Rotate
         //----------------
         int ctlbase = cylinderRect.left + image.cx + gap7 +
                       eyeScrollerRect.Width() + gap8 +
                       eyeCaptionRect.Width() + gap12;

         wndpos = ::DeferWindowPos(wndpos, c_Rotate.m_hWnd, NULL,
                          /*  x */ ctlbase,
                          /*  y */ rotateRect.top,
                          /* cx */ rotateRect.Width(),
                          /* cy */ image.cy,
                                   SWP_NOZORDER);
         ctlbase += rotateRect.Width();
         //----------------
         // x_Rotate
         //----------------
         wndpos = ::DeferWindowPos(wndpos, x_Rotate.m_hWnd, NULL,
                          /*  x */ cylinderRect.left + image.cx + gap7 +
                                            eyeScrollerRect.Width() + gap8 +
                                            eyeCaptionRect.Width() + gap12 +
                                            rotateRect.Width() - rotateIconRect.Width(),
                          /*  y */ rotateIconRect.top,
                          /* cx */ 0,
                          /* cy */ 0,
                                   SWP_NOSIZE | SWP_NOZORDER);

         //----------------
         // c_VRotate
         //----------------
         wndpos = ::DeferWindowPos(wndpos, c_VRotate.m_hWnd, NULL,
                          /*  x */ cylinderRect.left + image.cx + gap7 +
                                           eyeScrollerRect.Width() + gap8 +
                                           eyeCaptionRect.Width() + gap12,
                          /*  y */ cylinderRect.top + image.cy + gap9,
                          /* cx */ 0,
                          /* cy */ 0,
                                   SWP_NOSIZE | SWP_NOZORDER);
         //----------------
         // c_Light
         //----------------
         wndpos = ::DeferWindowPos(wndpos, c_Light.m_hWnd, NULL,
                                   cylinderRect.left,
                                   cylinderRect.top + image.cy + gap9,
                                   image.cx,
                                   lightScrollerRect.Height(),
                                   SWP_NOZORDER);
         //----------------
         // c_VEye
         //----------------
         wndpos = ::DeferWindowPos(wndpos, c_VEye.m_hWnd, NULL,
                          /*  x */ cylinderRect.left + image.cx + gap7,
                          /*  y */ cylinderRect.top + image.cy + gap9,
                          /* cx */ 0,
                          /* cy */ 0,
                                   SWP_NOSIZE | SWP_NOZORDER);

         //----------------
         // x_Light
         //----------------
         wndpos = ::DeferWindowPos(wndpos, x_Light.m_hWnd, NULL,
                                   cylinderRect.left,
                                   cylinderRect.top + image.cy + gap9 + lightScrollerRect.Height() + gap10,
                                   image.cx,
                                   lightCaptionRect.Height(),
                                   SWP_NOZORDER);

         //----------------
         // c_Code
         //----------------
         wndpos = ::DeferWindowPos(wndpos, c_Code.m_hWnd, NULL,
                                   0, 
                                   cylinderRect.top + image.cy + gap9 +
                                          lightScrollerRect.Height() + gap10 +
                                          lightCaptionRect.Height() + gap11,
                                   client.Width(),
                                   codeRect.Height(),
                                   SWP_NOZORDER);

         //****************************************************************
         //              --------------------------------------------------+
         //                                   gap13                        |
         //            gap14              [c_Identity]                     |
         //                                                                |
         //            gap16 [.....c_M11.....]     [.....c_M12.....]       |
         //                                                                |
         //            gap16 [.....c_V21.....]     [.....c_V22.....]       |
         //                                                                |
         //            gap16 [.....c_M21.....]     [.....c_M22.....]       |
         //                                                                |
         //            gap16 [.....c_V21.....]     [.....c_V22.....]       |
         //                                                                |
         //            gap16 [.....c_DX......]     [.....c_DY......]       |
         //                                                                |
         //            gap17 [.....c_VDX.....]     [.....c_VDY.....]       |
         //                                     :  |                       |
         //                                     :  |                       |
         //            gap17                       |                       |
         //              --------------------------------------------------+

         CRect identityRect = GetClientCoordinates(c_Identity);
         CRect M11Rect = GetClientCoordinates(c_M11);
         CRect M12Rect = GetClientCoordinates(c_M12);
         CRect M21Rect = GetClientCoordinates(c_M21);
         CRect M22Rect = GetClientCoordinates(c_M22);
         CRect DXRect = GetClientCoordinates(c_DX);
         CRect DYRect = GetClientCoordinates(c_DY);

         CRect V11Rect = GetClientCoordinates(c_V11);
         CRect V12Rect = GetClientCoordinates(c_V12);
         CRect V21Rect = GetClientCoordinates(c_V21);
         CRect V22Rect = GetClientCoordinates(c_V22);
         CRect VDXRect = GetClientCoordinates(c_VDX);
         CRect VDYRect = GetClientCoordinates(c_VDY);

         int gap13 = identityRect.top;
         int gap14 = identityRect.left - rotateRect.right;
         int gap15 = V11Rect.top - identityRect.bottom;
         int gap16 = M11Rect.left - rotateRect.right;
         int gap17 = M12Rect.left - rotateRect.right;

         //----------------
         // c_Identity
         //----------------
         wndpos = ::DeferWindowPos(wndpos, c_Identity.m_hWnd, NULL,
                          /*  x */ ctlbase + gap14,
                          /*  y */ identityRect.top,
                                   0,0,
                                   SWP_NOSIZE | SWP_NOZORDER);

#define MoveWnd(id, gap)                                         \
         wndpos = ::DeferWindowPos(wndpos, c_##id.m_hWnd, NULL,  \
                                   ctlbase + (gap),              \
                                   id##Rect.top,                 \
                                   0,0,                          \
                                   SWP_NOSIZE | SWP_NOZORDER);
         //----------------
         // c_M11
         //----------------
         MoveWnd(M11, gap16);

         //----------------
         // c_M12
         //----------------
         MoveWnd(M12, gap17);

         //----------------
         // c_V11
         //----------------
         MoveWnd(V11, gap16);

         //----------------
         // c_V12
         //----------------
         MoveWnd(V12, gap17);

         //----------------
         // c_M21
         //----------------
         MoveWnd(M21, gap16);

         //----------------
         // c_M22
         //----------------
         MoveWnd(M22, gap17);
         
         //----------------
         // c_V21
         //----------------
         MoveWnd(V21, gap16);

         //----------------
         // c_V22
         //----------------
         MoveWnd(V22, gap17);

         //----------------
         // c_DX
         //----------------
         MoveWnd(DX, gap16);

         //----------------
         // c_DY
         //----------------
         MoveWnd(DY, gap17);

         //----------------
         // c_VDX
         //----------------
         MoveWnd(VDX, gap16);

         //----------------
         // c_VDY
         //----------------
         MoveWnd(VDY, gap17);

         ::EndDeferWindowPos(wndpos);
         x_Width.Invalidate();
         x_Light.Invalidate();
         c_Cylinder.Invalidate();
        } /* can resize */
     
    }

/****************************************************************************
*                        CCylinderDlg::OnGetMinMaxInfo
* Inputs:
*       MINMAXINFO * lpMMI:
* Result: void
*       
* Effect: 
*       Limits the resize
****************************************************************************/

void CCylinderDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
    {
     CRect r;
     if(c_EnableTransform.GetSafeHwnd() != NULL)
        { /* has checkbox */
         if(c_EnableTransform.GetCheck() == BST_CHECKED)
            { /* matrix form */
             if(c_MatrixFrame.GetSafeHwnd() != NULL)
                { /* limit to matrix size */
                 c_MatrixFrame.GetWindowRect(&r);
                 ScreenToClient(&r);

                 CalcWindowRect(&r);
                 lpMMI->ptMinTrackSize = CPoint(r.Width(), r.Height());
                } /* limit to matrix size */
            } /* matrix form */
         else
            { /* non-matrix form */
             if(c_Frame.GetSafeHwnd() != NULL)
                { /* limit it */
                 c_Frame.GetWindowRect(&r);
                 ScreenToClient(&r);

                 CalcWindowRect(&r);
                 lpMMI->ptMinTrackSize = CPoint(r.Width(), r.Height());
                } /* limit it */
            } /* non-matrix form */
        } /* has checkbox */
     CDialog::OnGetMinMaxInfo(lpMMI);
    }

/****************************************************************************
*                           CCylinderDlg::GetColor
* Inputs:
*       COLORREF & c: Color reference
* Result: BOOL
*       TRUE if successful
*       FALSE if error
* Effect: 
*       Prompts the user for a color
****************************************************************************/

BOOL CCylinderDlg::GetColor(COLORREF & c)
    {
     CColorDialog dlg(c, CC_ANYCOLOR | CC_FULLOPEN | CC_RGBINIT);
     if(dlg.DoModal() != IDOK)
        return FALSE;
     c = dlg.m_cc.rgbResult;
     return TRUE;
    } // CCylinderDlg::GetColor


/****************************************************************************
*                      CCylinderDlg::OnBnClickedDarkcolor
* Result: void
*       
* Effect: 
*       Sets the dark color
****************************************************************************/

void CCylinderDlg::OnBnClickedDarkcolor()
    {
     COLORREF c = c_Cylinder.GetDarkColor();
     if(!GetColor(c))
        return;
     c_Cylinder.SetDarkColor(c);
     c_SetLight.SetDarkColor(c);
     c_SetDark.SetDarkColor(c);
    }


/****************************************************************************
*                     CCylinderDlg::OnBnClickedLightcolor
* Result: void
*       
* Effect: 
*       Sets the light color
****************************************************************************/

void CCylinderDlg::OnBnClickedLightcolor()
    {
     COLORREF c = c_Cylinder.GetLightColor();
     if(!GetColor(c))
        return;
     c_Cylinder.SetLightColor(c);
     c_SetLight.SetLightColor(c);
     c_SetDark.SetLightColor(c);
    }


/****************************************************************************
*                     CCylinderDlg::OnBnClickedEnableXform
* Result: void
*       
* Effect: 
*       Enables the transform matrix option
****************************************************************************/

void CCylinderDlg::OnBnClickedEnableXform()
    {
     SetMatrix();
     updateControls();
    }

/****************************************************************************
*                          CCylinderDlg::SetIdentity
* Result: void
*       
* Effect: 
*       Sets the matrix to the identity matrix
****************************************************************************/

void CCylinderDlg::SetIdentity()
    {
     c_M11.SetPos((int)TRANSFORM_FACTOR);  // 1.000
     c_M12.SetPos(0);
     c_M21.SetPos(0);
     c_M22.SetPos((int)TRANSFORM_FACTOR);  // 1.000
     c_DX.SetPos(0);
     c_DY.SetPos(0);
     c_Rotate.SetPos(0);
    } // CCylinderDlg::SetIdentity


/****************************************************************************
*                      CCylinderDlg::OnBnClickedIdentity
* Result: void
*       
* Effect: 
*       Sets the matrix to the identity matrix, and forces an update
****************************************************************************/

void CCylinderDlg::OnBnClickedIdentity()
    {
     SetIdentity();
     SetMatrix();
    }


/****************************************************************************
*                           CCylinderDlg::ZeroData
* Result: void
*       
* Effect: 
*       Sets the controls to their initial point
****************************************************************************/

void CCylinderDlg::ZeroData()
    {
     c_Eye.SetPos(20);
     c_Height.SetPos(50);
     c_Light.SetPos(0);
     c_Width.SetPos(20);
    } // CCylinderDlg::ZeroData

/****************************************************************************
*                        CCylinderDlg::OnBnClickedZero
* Result: void
*       
* Effect: 
*       "Zeros" the controls
****************************************************************************/

void CCylinderDlg::OnBnClickedZero()
    {
     ZeroData();
     c_Cylinder.SetLightingAngle(c_Light.GetPos());
     c_Cylinder.SetEyeAngle(c_Eye.GetPos());
     c_Cylinder.SetHeight(c_Height.GetPos());
     c_Cylinder.SetWidth(c_Width.GetPos());
     c_Cylinder.Invalidate();
    }


/****************************************************************************
*                        CCylinderDlg::OnBnClickedCopy
* Result: void
*       
* Effect: 
*       Copies the image to the clipboard
****************************************************************************/

void CCylinderDlg::OnBnClickedCopy()
    {
     toClipboard(&c_Cylinder);
    }
