// CylinderDlg.h : header file
//

#pragma once
#include "afxcmn.h"
#include "afxwin.h"

#include "SliderCtrlEx.h"
#include "Sample.h"
#include "RotatedText.h"
#include "GradientButton.h"
#include "ImageButton.h"

// CCylinderDlg dialog
class CCylinderDlg : public CDialog
{
// Construction
public:
        CCylinderDlg(CWnd* pParent = NULL);     // standard constructor

// Dialog Data
        enum { IDD = IDD_CYLINDER_DIALOG };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);        // DDX/DDV support


// Implementation
protected:
        HICON m_hIcon;
        CFont Vertical90;
        CFont Vertical270;

        CRect GetClientCoordinates(CWnd & wnd);

        // Generated message map functions
protected:
        virtual BOOL OnInitDialog();
        void updateControls();
        void SetMatrix();
        void SetIdentity();
        void DoRotate();
        void ShowDegrees(CEdit & ctl, int degrees);
        void ZeroData();

        BOOL GetColor(COLORREF & c);
        afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
        afx_msg void OnPaint();
        afx_msg HCURSOR OnQueryDragIcon();
        DECLARE_MESSAGE_MAP()
        virtual void OnOK();
        virtual void OnCancel();

    afx_msg void OnClose();
    afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
    afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnGetMinMaxInfo(MINMAXINFO* lpMMI);
    afx_msg void OnBnClickedDarkcolor();
    afx_msg void OnBnClickedLightcolor();
    afx_msg void OnBnClickedEnableXform();
    afx_msg void OnBnClickedIdentity();
    afx_msg void OnBnClickedZero();
protected:
    CGradientButton c_SetDark;
    CGradientButton c_SetLight;
    CSliderCtrl c_Width;
    CSliderCtrl c_Light;
    CSliderCtrlEx c_Height;
    CSliderCtrlEx c_Eye;
    CRotatedText x_Eye;
    CRotatedText x_Height;
    CStatic x_Width;
    CStatic x_Light;
    CSample c_Cylinder;
    CEdit c_Code;
    CStatic c_Frame;
    CSliderCtrl c_M11;
    CSliderCtrl c_M12;
    CSliderCtrl c_M22;
    CSliderCtrl c_M21;
    CButton c_EnableTransform;
    CSliderCtrl c_DX;
    CSliderCtrl c_DY;
    CImageButton c_Identity;
    CSliderCtrlEx c_Rotate;
    CEdit c_V11;
    CEdit c_V12;
    CEdit c_V21;
    CEdit c_V22;
    CEdit c_VDX;
    CEdit c_VDY;
    CStatic x_Rotate;
    CEdit c_VRotate;
    CEdit c_VEye;
    CStatic c_MatrixFrame;
    CImageButton c_Copy;
public:
    afx_msg void OnBnClickedCopy();
};
