// SliderCtrlEx.cpp : implementation file
//

#include "stdafx.h"
#include "SliderCtrlEx.h"


// CSliderCtrlEx

IMPLEMENT_DYNAMIC(CSliderCtrlEx, CSliderCtrl)
CSliderCtrlEx::CSliderCtrlEx()
  {
   low = 0;
   high = 100;
  }

CSliderCtrlEx::~CSliderCtrlEx()
{
}


BEGIN_MESSAGE_MAP(CSliderCtrlEx, CSliderCtrl)
END_MESSAGE_MAP()



// CSliderCtrlEx message handlers


/****************************************************************************
*                         CSliderCtrlEx::SetRange
* Inputs:
*       int top:  The value represented at the top of the slider
*       int bottom: The value represented at the bottom of the slider
* Result: void
*       
* Effect: 
*       Sets the range
* Examples
*       Virtual         Actual          Virtual         Actual
*       SetRange        SetRange        SetPos          SetPos
*       top bottom
*       90  -90         0, 180          20              70
*       90  -90         0, 180          -20             110
*       -90  90         0, 180          20              110
*       -90  90         0, 180          -20             70
*                                                       abs(low-pos)
****************************************************************************/

void CSliderCtrlEx::SetRange(int top, int bottom)
    {
     low = bottom;
     high = top;
     CSliderCtrl::SetRange(0, abs(top - bottom));
    } // CSliderCtrlEx::SetRange

/****************************************************************************
*                          CSliderCtrlEx::SetPos
* Inputs:
*       int pos: Desired position
* Result: void
*       
* Effect: 
*       Sets the position
****************************************************************************/

void CSliderCtrlEx::SetPos(int pos)
    {
     //  top            bottom
     //  
     CSliderCtrl::SetPos(abs(low - pos));
    } // CSliderCtrlEx::SetPos

/****************************************************************************
*                          CSliderCtrlEx::GetPos
* Result: int
*       Retrieves the position
****************************************************************************/

int CSliderCtrlEx::GetPos()
    {
        return low - CSliderCtrl::GetPos(); 
    } // CSliderCtrlEx::GetPos

/****************************************************************************
*                          CSliderCtrlEx::GetPosRaw
* Result: int
*       The raw position
****************************************************************************/

int CSliderCtrlEx::GetPosRaw()
    {
     return CSliderCtrl::GetPos();
    } // CSliderCtrlEx::GetPosRaw

/****************************************************************************
*                           CSliderCtrlEx::GetRange
* Inputs:
*       int & low:
*       int & high:
* Result: void
*       
* Effect: 
*       
****************************************************************************/

void CSliderCtrlEx::GetRange(int & bottom, int & top)
    {
     bottom = low;
     top = high;
    } // CSliderCtrlEx::GetRange
